//This program will take a tab-delimited text file of the form
//S1    E1    TAG1     S2    E2    TAG2
//And will attempt to group similar regions together
//PSEUDO-CODE
//INPUT TAB DELIMTED FILE
//TAKE LINE N
//IF newFamily
//	create newFamily
//ELSE
// find the proper family and add

import java.io.*;
import java.util.*;

public class getFamily {
	public static void main(String[] args) {
		//INPUT FILE
		try{
			File source = new File("C:\\Users\\Harry\\Documents\\cgigas\\shortMSPraw.txt");
			Scanner console = new Scanner(source);
			//OUTPUT FILE
			PrintStream output= new PrintStream("families.txt");
		
			//VARIABLES
			Map<String,Set<String>> families=new  HashMap<String,Set<String>>();
				while (console.hasNextLine()) {
					//GRAB LINE N 
					String line=console.nextLine();
					//Create an identified for the sequence names SequenceName_Start_End
					//Split line along tabs (tab delimited)
					String[] fields=line.split("	");
					//This is made up of a subject(first) and query(second)
					String subject=fields[2] + "|" + fields[0] + "|" + fields[1];
					String query=fields[5] + "|" + fields[3] + "|" + fields[4];
					line=null;
					fields=null;
					//Is tag1 a key?
					if (families.containsKey(subject)){//tag1 is a key
						//Is tag2 a value?
						Set values= families.get(subject);
						if (!values.contains(query)){
							values.add(query);
						}
						families.put(subject,values);
					}else{//tag1 is NOT a key
						//Is tag 2 a key?
						if(families.containsKey(query)){//tag2 is a key
							//Is tag1 a value?
							Set values= families.get(query);
							if (!values.contains(subject)){
								values.add(subject);
							}
							families.put(query,values);
						}else{//neither tag1 or tag2 are keys
							Iterator it = families.keySet().iterator();
							boolean found=false;
							String cKey="";
							while(it.hasNext()){//Iterate through keys
								cKey=it.next().toString();
								Set values= families.get(cKey);
								if(values.contains(subject) || values.contains(query)){//if either tag1 or tag2 are there
									values.add(subject);
									values.add(query);//add both (its a set redundancy be damned)
									families.put(cKey,values);
									found=true;
									break;
								}
							}
							if(!found){
								Set values= new HashSet();
								values.add(query);
								families.put(subject,values);
							}
						}
					}
				}
				System.out.println("There are a total of " + families.size() + " families in the given MSP list");
		}catch (FileNotFoundException ex) {
		      ex.printStackTrace();
				System.out.println("Problem Reading the File");
		}
	}
}
